Imports System
Imports System.Runtime.InteropServices
Imports System.Windows.Forms

Public Class ShowFolderPathForm
    Inherits AddinExpress.OL.ADXOlForm

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents lblFolderPath As System.Windows.Forms.LinkLabel
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(ShowFolderPathForm))
        Me.Label1 = New System.Windows.Forms.Label
        Me.lblFolderPath = New System.Windows.Forms.LinkLabel
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Dock = System.Windows.Forms.DockStyle.Left
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
        Me.Label1.Location = New System.Drawing.Point(2, 4)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(90, 22)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Folder Path:"
        '
        'lblFolderPath
        '
        Me.lblFolderPath.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lblFolderPath.Location = New System.Drawing.Point(92, 4)
        Me.lblFolderPath.Name = "lblFolderPath"
        Me.lblFolderPath.Size = New System.Drawing.Size(104, 22)
        Me.lblFolderPath.TabIndex = 1
        Me.lblFolderPath.TabStop = True
        Me.lblFolderPath.Text = "test-test"
        Me.ToolTip1.SetToolTip(Me.lblFolderPath, "Click to make this folder active in the main Outlook window")
        '
        'PictureBox1
        '
        Me.PictureBox1.BackColor = System.Drawing.Color.Transparent
        Me.PictureBox1.Cursor = System.Windows.Forms.Cursors.Hand
        Me.PictureBox1.Dock = System.Windows.Forms.DockStyle.Right
        Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Image)
        Me.PictureBox1.Location = New System.Drawing.Point(196, 4)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(140, 22)
        Me.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage
        Me.PictureBox1.TabIndex = 2
        Me.PictureBox1.TabStop = False
        '
        'ShowFolderPathForm
        '
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.None
        Me.ClientSize = New System.Drawing.Size(338, 28)
        Me.Controls.Add(Me.lblFolderPath)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.PictureBox1)
        Me.Name = "ShowFolderPathForm"
        Me.Padding = New System.Windows.Forms.Padding(2, 4, 2, 2)
        Me.Text = "Containing Folder"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private FolderEntryID As String

    Private Sub ShowFolderPathForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim objFolder As Outlook.MAPIFolder = Nothing
        Dim objItem As Object = Nothing

        FolderEntryID = String.Empty
        Me.lblFolderPath.Text = String.Empty

        Try
            objItem = InspectorObj.CurrentItem
            If objItem IsNot Nothing Then
                Try
                    objFolder = objItem.Parent
                    If objFolder IsNot Nothing Then
                        FolderEntryID = objFolder.EntryID
                        Dim strFolderName As String = objFolder.Name
                        Dim strFolderPath As String = GetFolderPath(objFolder)
                        Me.lblFolderPath.Text = strFolderName + " (" + strFolderPath + ")"
                        Me.lblFolderPath.LinkArea = New LinkArea((strFolderName + " (").Length, strFolderPath.Length)
                    End If
                Finally
                    Marshal.ReleaseComObject(objItem)
                End Try
            End If
        Catch
        End Try
    End Sub

    Private Sub ShowFolderPathForm_ADXBeforeFormShow() Handles MyBase.ADXBeforeFormShow
        Dim objItem As Object = Nothing
        Try
            objItem = InspectorObj.CurrentItem
            If objItem IsNot Nothing Then
                Try
                    Dim entryID As String = objItem.EntryID
                    If String.IsNullOrEmpty(entryID) Then
                        Me.Visible = False
                    End If
                Finally
                    Marshal.ReleaseComObject(objItem)
                End Try
            End If
        Catch
        End Try
    End Sub

    Function GetFolderPath(ByVal objFolder As Outlook.MAPIFolder) As String
        Dim strFolderPath As String
        Dim objChild As Outlook.MAPIFolder
        Dim objParent As Outlook.MAPIFolder

        strFolderPath = "\" + objFolder.Name
        objChild = objFolder

        While objChild IsNot Nothing
            Try
                objParent = objChild.Parent
            Catch
                objParent = Nothing
            Finally
                If objChild IsNot Nothing Then
                    Marshal.ReleaseComObject(objChild)
                End If
            End Try
            If objParent Is Nothing Then Exit While
            strFolderPath = "\" + objParent.Name + strFolderPath
            objChild = objParent
        End While

        Return "\" + strFolderPath
    End Function

    Private Sub lblFolderPath_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lblFolderPath.LinkClicked
        Dim olApp As Outlook._Application = Me.OutlookAppObj

        Dim parentFolder As Outlook.MAPIFolder = Nothing
        Dim ns As Outlook._NameSpace = olApp.GetNamespace("MAPI")
        If ns IsNot Nothing Then
            Try
                parentFolder = ns.GetFolderFromID(FolderEntryID, Type.Missing)
            Finally
                Marshal.ReleaseComObject(ns)
            End Try
        End If

        If parentFolder IsNot Nothing Then
            Try
                Dim activeExplorer As Outlook._Explorer = Nothing
                Try
                    activeExplorer = olApp.ActiveExplorer()
                Catch
                End Try
                If activeExplorer Is Nothing Then
                    activeExplorer = parentFolder.GetExplorer(Outlook.OlFolderDisplayMode.olFolderDisplayNormal)
                End If

                If activeExplorer IsNot Nothing Then
                    Try
                        activeExplorer.CurrentFolder = parentFolder
                        activeExplorer.Activate()
                    Finally
                        Marshal.ReleaseComObject(activeExplorer)
                    End Try
                End If
            Catch
            Finally
                Marshal.ReleaseComObject(parentFolder)
            End Try
        End If
    End Sub

    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click
        Dim procShell As System.Diagnostics.Process = New System.Diagnostics.Process()
        procShell.StartInfo.FileName = "http://www.add-in-express.com/add-in-net/outlook-regions-basics.php?ref1=show-containing-folder-addin"
        procShell.StartInfo.UseShellExecute = True
        procShell.StartInfo.RedirectStandardOutput = False
        procShell.Start()
    End Sub
End Class
